IMPLEMENTATION MODULE Clock;

   FROM SYSTEM	IMPORT ADR, UNIXCALL;
   FROM Sys	IMPORT getrusage;	(* Nixdorf: times *)
   FROM SysTime IMPORT Time;
   FROM SystemTypes IMPORT TIME;

   TYPE Buf = RECORD u,s,cu,cs: CARDINAL END;

   VAR
      ignore,
      real,
      cpu:  CARDINAL;

   PROCEDURE Times(VAR buf: Buf): CARDINAL;
   TYPE
	TIMEVAL = RECORD sec, usec : CARDINAL END;	(*see <sys/time.h*)
	RUSAGE = RECORD		(*see <sys/resource.h>*) 
		    utime : TIMEVAL;
		    stime : TIMEVAL;
		    maxrss : CARDINAL;
		    ixrss : CARDINAL;
		    idrss : CARDINAL;
		    isrss : CARDINAL;
		    minflt : CARDINAL;
		    majflt : CARDINAL;
		    nswap : CARDINAL;
		    inblock : CARDINAL;
		    oublock : CARDINAL;
		    msgsnd : CARDINAL;
		    nsignals : CARDINAL;
		    nvcsw : CARDINAL;
		    nivcsw : CARDINAL
		END;
   CONST
	SELF = 0;
	CHILD = 1;
      VAR r0, r1: CARDINAL;
	  time : TIME;
	  rusage : RUSAGE;
   BEGIN
      IF UNIXCALL(getrusage,r0,r1,SELF,ADR(rusage)) THEN
         buf.u := rusage.utime.sec;
	 buf.s := rusage.stime.sec;
      END;
      IF UNIXCALL(getrusage,r0,r1,CHILD,ADR(rusage)) THEN
         buf.cu := rusage.utime.sec;
	 buf.cs := rusage.stime.sec;
      END;
      IF Time( time) THEN
          RETURN time
      END;
   END Times;

   PROCEDURE RealTime(reset: BOOLEAN): CARDINAL;
      VAR
	 result: CARDINAL;
	 buf:	 Buf;
   BEGIN
      result := Times(buf) - real;
      IF reset THEN
	 INC(real,result)
      END;
      RETURN result
   END RealTime;

   PROCEDURE CPUTime (reset: BOOLEAN): CARDINAL;
      VAR
	 result: CARDINAL;
	 buf:	 Buf;
   BEGIN
      ignore := Times(buf);
      WITH buf DO
	 result := u + s + cu + cs - cpu;
      END;
      IF reset THEN
	 INC(cpu,result)
      END;
      RETURN result
   END CPUTime;

BEGIN
   ignore := RealTime(TRUE);
   cpu := 0;
   DEC(real, CPUTime(FALSE) );
END Clock.
