(* Modula-2 Library    -  UNIX System V  -     AFB 5/88 *)
(* (c) Universitaet Ulm, Sektion Informatik, D-7900 Ulm *)
(*%p+*)
DEFINITION MODULE TermCap;

   FROM SYSTEM IMPORT BYTE;

   CONST
      stringlen = 64;
   TYPE
      String = ARRAY [0..stringlen-1] OF CHAR;
      OutProc = PROCEDURE (CHAR);
      DelayProc = PROCEDURE (CARDINAL);
      Term =
	 RECORD
           TMT: BOOLEAN;
           AutoRightMargin: BOOLEAN;
           Tbs: BOOLEAN;
           AutoLeftMargin: BOOLEAN;
           MemoryAbove: BOOLEAN;
           MemoryBelow: BOOLEAN;
           EraseOverstrike: BOOLEAN;
           Tes: BOOLEAN;
           HardCopy: BOOLEAN;
           Ths: BOOLEAN;
           InsertNullGlitch: BOOLEAN;
           Tkm: BOOLEAN;
           MoveInsertMode: BOOLEAN;
           Tms: BOOLEAN;
           Tnc: BOOLEAN;
           Tns: BOOLEAN;
           OverStrike: BOOLEAN;
           Tpl: BOOLEAN;
           Tpt: BOOLEAN;
           TransparentUnderline: BOOLEAN;
           BeehiveGlitch: BOOLEAN;
           EatNewlineGlitch: BOOLEAN;
           Txo: BOOLEAN;
           Txr: BOOLEAN;
           CeolStandoutGlitch: BOOLEAN;
           TelerayGlitch: BOOLEAN;
           Columns: INTEGER;
           TdC: INTEGER;
           TdF: INTEGER;
           TdN: INTEGER;
           TdT: INTEGER;
           Tkn: INTEGER;
           Lines: INTEGER;
           Tpb: INTEGER;
           MagicCookieGlitch: INTEGER;
           Tug: INTEGER;
           Tvt: INTEGER;
           TAL: String;
           CommandCharacter: String;
           TDC: String;
           TDL: String;
           TDO: String;
           TIC: String;
           TLE: String;
           TRI: String;
           TUP: String;
           ExitAltCharsetMode: String;
           InsertLine: String;
           EnterAltCharsetMode: String;
           Tbc: String;
           Tbl: String;
           BackTab: String;
           ClrEos: String;
           ClrEol: String;
           ColumnAddress: String;
           ClearScreen: String;
           CursorAddress: String;
           CarriageReturn: String;
           ChangeScrollRegion: String;
           Tct: String;
           RowAddress: String;
           DeleteCharacter: String;
           DeleteLine: String;
           EnterDeleteMode: String;
           CursorDown: String;
           Tds: String;
           ExitDeleteMode: String;
           ExitInsertMode: String;
           FormFeed: String;
           Tfs: String;
           DownHalfLine: String;
           CursorHome: String;
           UpHalfLine: String;
           Ti2: String;
           InsertCharacter: String;
           InitFile: String;
           EnterInsertMode: String;
           InsertPadding: String;
           Tis: String;
           KeyF0: String;
           KeyF1: String;
           KeyF2: String;
           KeyF3: String;
           KeyF4: String;
           KeyF5: String;
           KeyF6: String;
           KeyF7: String;
           KeyF8: String;
           KeyF9: String;
           KeyBackspace: String;
           KeyDown: String;
           KeypadLocal: String;
           KeyHome: String;
           KeyLeft: String;
           Tko: String;
           KeyRight: String;
           KeypadXmit: String;
           KeyUp: String;
           LabF0: String;
           LabF1: String;
           LabF2: String;
           LabF3: String;
           LabF4: String;
           LabF5: String;
           LabF6: String;
           LabF7: String;
           LabF8: String;
           Tle: String;
           CursorToLl: String;
           Tma: String;
           Tmb: String;
           Tmd: String;
           Tme: String;
           Tmh: String;
           Tmk: String;
           Tmp: String;
           Tmr: String;
           CursorRight: String;
           Tnl: String;
           Tnw: String;
           PadChar: String;
           Trc: String;
           Trf: String;
           Tri: String;
           Trs: String;
           Tsc: String;
           ExitStandoutMode: String;
           Tsf: String;
           EnterStandoutMode: String;
           ScrollReverse: String;
           Tst: String;
           Tab: String;
           Ttc: String;
           ExitCaMode: String;
           EnterCaMode: String;
           Tts: String;
           UnderlineChar: String;
           ExitUnderlineMode: String;
           CursorUp: String;
           EnterUnderlineMode: String;
           FlashScreen: String;
           CursorNormal: String;
           CursorVisible: String;
	 END;

   PROCEDURE SetupTerm(tname: ARRAY OF CHAR; VAR tinfo: Term) : BOOLEAN;

   PROCEDURE Tparm(VAR out: ARRAY OF CHAR; fmt: ARRAY OF CHAR);

   PROCEDURE Tparm1(VAR out: ARRAY OF CHAR; fmt: ARRAY OF CHAR;
		    arg1: ARRAY OF BYTE);

   PROCEDURE Tparm2(VAR out: ARRAY OF CHAR; fmt: ARRAY OF CHAR;
		    arg1: ARRAY OF BYTE;
		    arg2: ARRAY OF BYTE);

   PROCEDURE Tparm3(VAR out: ARRAY OF CHAR; fmt: ARRAY OF CHAR;
		    arg1: ARRAY OF BYTE;
		    arg2: ARRAY OF BYTE;
		    arg3: ARRAY OF BYTE);

   PROCEDURE Tparm4(VAR out: ARRAY OF CHAR; fmt: ARRAY OF CHAR;
		    arg1: ARRAY OF BYTE;
		    arg2: ARRAY OF BYTE;
		    arg3: ARRAY OF BYTE;
		    arg4: ARRAY OF BYTE);

   PROCEDURE Tparm9(VAR out: ARRAY OF CHAR; fmt: ARRAY OF CHAR;
		    arg1: ARRAY OF BYTE;
		    arg2: ARRAY OF BYTE;
		    arg3: ARRAY OF BYTE;
		    arg4: ARRAY OF BYTE;
		    arg5: ARRAY OF BYTE;
		    arg6: ARRAY OF BYTE;
		    arg7: ARRAY OF BYTE;
		    arg8: ARRAY OF BYTE;
		    arg9: ARRAY OF BYTE);

   PROCEDURE Tputs(str: ARRAY OF CHAR; affcnt: CARDINAL;
		   outc: OutProc);

   PROCEDURE TputsDelay(str: ARRAY OF CHAR; affcnt: CARDINAL;
			outc: OutProc; delay: DelayProc);

END TermCap.
